/*
 *  TOPPERS/OSEK Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      OSEK Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2006 by Witz Corporation, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/*
 *  vZbTˑW[iSH2pj
 */


#ifndef	_CPU_CONFIG_H_
#define	_CPU_CONFIG_H_

#define MAX_IPM  0xf	/* X^uȂ̏ꍇ͍ōDxCPUbN */


#ifndef _MACRO_ONLY
#include "cpu_insn.h"
#endif /* _MACRO_ONLY */


#ifndef _MACRO_ONLY
/* CC֐vg^Cv錾	*/
Inline void set_ipl(UINT8 ipl);
Inline UINT8 current_ipl(void);

extern UINT32 lock_flag;
extern UINT32 intmask;

/*
 *  {OSJ[lł͊ݐItOyIPL̑opčs
 *  ƂOƂD{CPUIPL݂̂Ȃ߁A
 *  ItO\tgEFAŕ₤dlƂ
 */

/*
 *  ݗDxxݒ
 */
Inline void set_ipl(UINT8 ipl)
{
	/*
	 *  CPUbNǂ肵AbNłȂ
	 *  SRWX^ɒڐݒ肷DbNł
	 *  intmaskIPLۑD
	 */
	if(lock_flag == 0){
		set_sr(ipl << 4);
	}
	else{
		intmask = ipl << 4;
	}
}


/*
 *  ݗDxx擾
 */
Inline UINT8 current_ipl(void)
{
	/*
	 *  CPUbNǂ肵AbNłȂ
	 *  SRWX^璼ړǂݏoDbNł
	 *  intmaskIPLǂݏoD
	 */
	if(lock_flag == 0)
	{
		return (UINT8)((current_sr() & 0x000000f0u ) >> 4);
	}
	else
	{
		return intmask >> 4;
	}
}


/*
 *  vZbTˑ̏(cpu_config.c)
 */
extern void	cpu_initialize(void);

/*
 *  vZbTˑ̏I(cpu_config.c)
 */
extern void	cpu_terminate(void);

#define DEFINE_CTXB(tnum) \
FP tcxb_pc[tnum]; \
VP tcxb_sp[tnum];

extern FP tcxb_pc[];
extern VP tcxb_sp[];

/* fBXpb`̃AZu֐vg^Cv錾	*/
extern void  dispatch(void);
extern void  exit_and_dispatch(void);
extern void  start_dispatch(void);


/*
 *  ISR1}N
 *
 *  ISR1̑SĂ̏[ULqꍇ́Ccpu_defs.h ɂ閳}N
 *  uOMIT_ISR1_ENTRYv̒`Lɂ邱ƁD
 */

/*
 *  OQƐ錾}N
 */
#if defined(OMIT_ISR1_ENTRY)
#define ISR1_EXTERNAL(isr)	\
	extern void isr(void);
#else	/* OMIT_ISR1_ENTRY	*/
#define ISR1_EXTERNAL(isr)	\
	extern void isr##_entry(void);
#endif	/* OMIT_ISR1_ENTRY	*/

/* xN^e[uo^V{}N	*/
#if defined(OMIT_ISR1_ENTRY)
#define	ISR1_SYMBOL(isr)		#isr
#else	/* OMIT_ISR1_ENTRY	*/
#define	ISR1_SYMBOL(isr)		isr##_entry
#endif	/* OMIT_ISR1_ENTRY	*/

/* ̐}N	*/
#if defined(OMIT_ISR1_ENTRY)
#define ISR1_ENTRY(isr)
#else	/* OMIT_ISR1_ENTRY	*/
#define ISR1_ENTRY(isr)\
asm("	.globl _" #isr);\
asm("	.section \".text\", \"ax\"	");\
asm("	.align	2");	\
asm("_" #isr "_entry:");\
asm("	mov.l	r0 , @-r15");	\
asm("	mov.l	r1 , @-r15");	\
asm("	mov.l	r2 , @-r15");	\
asm("	mov.l	r3 , @-r15");	\
asm("	mov.l	r4 , @-r15");	\
asm("	mov.l	r5 , @-r15");	\
asm("	mov.l	r6 , @-r15");	\
asm("	mov.l	r7 , @-r15");	\
asm("	sts.l	pr , @-r15");	\
asm("	sts.l	macl , @-r15");	\
asm("	sts.l	mach , @-r15");	\
asm("	stc.l	gbr , @-r15");	\
asm("	mov.l	_" #isr "_adr , r0");	\
asm("	jsr @r0");	\
asm("	nop");	\
asm("	ldc.l	@r15+ , gbr");	\
asm("	lds.l	@r15+ , mach");	\
asm("	lds.l	@r15+ , macl");	\
asm("	lds.l	@r15+ , pr");	\
asm("	mov.l	@r15+ , r7");	\
asm("	mov.l	@r15+ , r6");	\
asm("	mov.l	@r15+ , r5");	\
asm("	mov.l	@r15+ , r4");	\
asm("	mov.l	@r15+ , r3");	\
asm("	mov.l	@r15+ , r2");	\
asm("	mov.l	@r15+ , r1");	\
asm("	mov.l	@r15+ , r0");	\
asm("	rte	");	\
asm("	nop");	\
asm(".align	4");	\
asm("_" #isr "_adr:");	\
asm("	.long	_" #isr);
#endif	/* OMIT_ISR1_ENTRY	*/

/*
 *  ISR2}N
 */

/*
 *	OQƐ錾}N
 */
#define ISR2_EXTERNAL(isr)	\
	extern void isr##_entry(void);

/* xN^e[uo^V{}N	*/
#define	ISR2_SYMBOL(isr)		isr##_entry

/* ̐}N	*/
#define ISR2_ENTRY(isr, isrid)	\
asm("	.globl _runisr	");													\
asm("	.globl _ISRMain" #isr);												\
asm("	.globl _interrupt	");												\
asm("	.section \".text\" , \"ax\"	");										\
asm("	.align	2");														\
asm("_" #isr "_entry:					");									\
asm("	mov.l	r0 , @-r15	/* Œ̃WX^ޔ */");					\
asm("	mov.l	r1 , @-r15");												\
asm("	mov.l	r2 , @-r15");												\
asm("	stc		sr , r2		/* SRWX^ޔ */");						\
asm("	mov.l	_maxipm_"	#isr	" , r1	/* 荞݋֎~ */");			\
asm("	ldc 	r1 , sr");													\
asm("	mov.l	r3 , @-r15");												\
asm("	mov.l	_runisr_"	#isr	"_adr, r3		");						\
asm("	mov.b	@r3 , r1	/* runisrXV */");							\
asm("	mov		#" #isrid " , r0");											\
asm("	mov.b	r0 , @r3			");										\
asm("	mov.l	_ISRMain" #isr "_adr , r0	/* ISR̃AhXۑ */");	\
asm("	mov.l	_interrupt_"	#isr	"_adr , r3");						\
asm("	jmp	@r3		/* 荞݋ʕ */");								\
asm("	nop");																\
asm(".align	4	");															\
asm("_interrupt_"	#isr	"_adr:	");										\
asm("	.long	_interrupt	");												\
asm("_runisr_"	#isr	"_adr:	");											\
asm("	.long	_runisr	");													\
asm("_ISRMain" #isr "_adr:	");												\
asm("	.long	_ISRMain" #isr);											\
asm("_maxipm_"	#isr ":");													\
asm("	.long	0x000000f0");



/*
 *  gpݐ}N
 */

/* xN^e[ůOQƐ錾}N	*/
#define	UNUSED_INT_EXTERNAL()	extern void unused_interrupt(void);

/* xN^e[uo^V{}N	*/
#define	UNUSED_INT_SYMBOL()		unused_interrupt


/*
 *  tbN[`NULLV{}N
 */
#define	NULL_ERRORHOOK \
asm(".globl	_ErrorHook");\
asm("	.equ _ErrorHook , 0");

#define	NULL_STARTUPHOOK \
asm(".globl	_StartupHook");\
asm("	.equ _StartupHook , 0");

#define	NULL_SHUTDOWNHOOK \
asm(".globl	_ShutdownHook"); \
asm("	.equ _ShutdownHook , 0");

#define	NULL_PRETASKHOOK \
asm(".globl	_PreTaskHook"); \
asm("	.equ	_PreTaskHook ,0");

#define	NULL_POSTTASKHOOK \
asm(".globl	_PostTaskHook"); \
asm("	.equ	_PostTaskHook , 0");



#endif /* _MACRO_ONLY */
#endif	/* _CPU_CONFIG_H_	*/

